#######################################################################################################################################
###################################################### ObjectSelectionSaver v1.2 ######################################################
#######################################################################################################################################
# For Lapper v7.0.6.1 and beyond.
#######################################################################################################################################
# Enable $DisplayObjectInfo flag in the main .lpr script (LFSLapper.lpr)!
#######################################################################################################################################
# List of commands:
#		!listsel	->	 open selections menu
#		!savebutt 	->	 show save button without the GUI
#		!savesel	->	 save selection to database
#		!loadsel	->	 load selection from database
#		!rensel		->	 rename selection
#		!delsel		->	 delete selection from database
#######################################################################################################################################
# Some info:
#	-	Only users with their username included in the superusers.txt file can delete/rename all selections,
#		otherwise a user can only delete/rename selections that he created.
#	-	Rightclicking +- buttons for changing the items per page number will increase/decrease the number by 5.
#	-	Clicking 'Num Of Items per page' button will open input window where you can type in the number.
#	-	Rightclicking 'next' or 'previous' paging buttons will jump to last/first page.
#	-	Rightclicking item buttons will copy the item name to the chat, you can use this for example to bring the name
#		to the 'rename' window by pressing up arrow button on your keyboard, just like you do when copying a link from chat etc.
#	-	The !savebutt command works as a switch - second execution will hide the Save button
#######################################################################################################################################
CatchEvent OnLapperStart()
	GlobalVar $oss_cfgPath;
	GlobalVar $oss_cfgFileName;
	GlobalVar $oss_dbsPath;
	GlobalVar $oss_dbsFileName;
	GlobalVar $oss_guiPos_X;
	GlobalVar $oss_guiPos_Y;
	GlobalVar $oss_boarderUP_H;
	GlobalVar $oss_boarderDOWN_H;
	GlobalVar $oss_boarderL_W;
	GlobalVar $oss_boarderR_W;
	GlobalVar $oss_background_X;
	GlobalVar $oss_background_Y;
	GlobalVar $oss_background_W;
	GlobalVar $oss_header_items_W;
	GlobalVar $oss_header_items_H;
	GlobalVar $oss_items_offset;
	GlobalVar $oss_header_name_W;
	GlobalVar $oss_header_date_W;
	GlobalVar $oss_header_user_W;
	GlobalVar $oss_header_count_W;
	GlobalVar $oss_header_ren_W;
	GlobalVar $oss_header_del_W;
	GlobalVar $oss_header_nduc_H;
	GlobalVar $oss_minItemsPerPage;
	GlobalVar $oss_maxItemsPerPage;
	GlobalVar $oss_maxNameLenght;
	GlobalVar $oss_confirmMsg_color;
	GlobalVar $oss_confirmMsg2_color;
	GlobalVar $oss_errorMsg_color;
	
	$oss_cfgPath = "..\bin\default\includes\ObjectSelectionSaver\files";
	$oss_cfgFileName = "users_cfg";
	$oss_dbsPath = "..\bin\default\includes\ObjectSelectionSaver\files";
	$oss_dbsFileName = "objects";
	
	$oss_confirmMsg_color = "^2";
	$oss_confirmMsg2_color = "^3";
	$oss_errorMsg_color = "^1";
	
	$oss_minItemsPerPage = 5;
	$oss_maxItemsPerPage = 30;
	
	$oss_guiPos_X = 100; # 0 to 200
	$oss_guiPos_Y = 9; # 0 to 200
	
	$oss_maxNameLenght = 25;
	
	$oss_boarderUP_H = 23;
	$oss_boarderDOWN_H = 7;
	$oss_boarderL_W = 8;
	$oss_boarderR_W = 8;
	
	$oss_header_name_W = 42;
	$oss_header_date_W = 22;
	$oss_header_user_W = 24;
	$oss_header_count_W = 6;
	$oss_header_ren_W = 5;
	$oss_header_del_W = 4;
	$oss_header_nduc_H = 3;
	$oss_header_items_W = $oss_header_name_W+$oss_header_date_W+$oss_header_user_W+$oss_header_count_W+$oss_header_del_W;
	$oss_header_items_H = 5;
	$oss_items_offset = $oss_header_items_H;

	$oss_background_W = round($oss_header_items_W+$oss_boarderL_W,0);
	$oss_background_X = round($oss_guiPos_X-(($oss_header_items_W/2)+($oss_boarderL_W/2)),0);
	$oss_background_Y = $oss_guiPos_Y;
EndCatchEvent

CatchEvent OnMSO( $userName, $text ) # Player event
	$idxOfFirtsSpace = indexOf( $text, " ");
	IF( $idxOfFirtsSpace == -1 ) THEN
	  $command = $text;
	  $argv = "";
	ELSE
	  $command = subStr( $text,0,$idxOfFirtsSpace );
	  $argv = trim( subStr( $text,$idxOfFirtsSpace ) );
	ENDIF

	SWITCH( $command )
		CASE "!listsel":	# selections menu
			### close separate Save button
			closePrivButton("selMenu_Header_SaveSelSep");
			SetCurrentPlayerVar("sepSaveButtIsOpen",0);
			###
			
			IF(UserIsServerAdmin($userName) == 1) THEN 
				$LinesofFile = ReadFile($oss_cfgFileName,$oss_cfgPath,".osscf");
				$NrOfLines = $LinesofFile["NumberOfLines"];
				FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
					$linenr = $LinesofFile[$i,"LineNumber"]+1;
					$line = $LinesofFile[$i,"Line"];
					
					$cfgLineInfo = SplitToArray($line,"|");
					$cfgLineUserName = $cfgLineInfo[0];
					IF($cfgLineUserName == $userName) THEN
						$userFound = 1;
						BREAK;
					ENDIF
				ENDFOR
				
				IF($userFound != 1) THEN
					EditFile($oss_cfgFileName,$oss_cfgPath,$userName."|"."date_DESC"."|"."10"."|"."1"."|"."1",-1,".osscf"); # create new line for new user
				ENDIF
				
				SetCurrentPlayerVar("selMenu_CurrPage",1);
		
				showSelMenuGUI(0,0);
			ELSE
				privMsg($oss_errorMsg_color . "Only for server admins");
			ENDIF
		BREAK;
		
		CASE "!savebutt":	# show save button without the GUI
				### closethe GUI
				closeButtonRegex( $userName, "selMenu_" );
				###
				
				IF(GetCurrentPlayerVar("sepSaveButtIsOpen") != 1) THEN
					openPrivTextButton( "selMenu_Header_SaveSelSep",
						31,
						0,
						8,
						4,
						3,
						4+ISB_DARK,
						"name the selection",
						"save%nl%current%nl%selection%nl% ▼",
						$oss_maxNameLenght,
						saveSel);
					SetCurrentPlayerVar("sepSaveButtIsOpen",1);
				ELSE
					closePrivButton("selMenu_Header_SaveSelSep");
					SetCurrentPlayerVar("sepSaveButtIsOpen",0);
				ENDIF
		BREAK;
		
		CASE "!savesel":	# save selection to database
			saveSel(0,$argv);
		BREAK;
		
		CASE "!loadsel":	# load selection from database
			loadSel(0,$argv);
		BREAK;
		
		CASE "!rensel":		# rename selection
			IF (Contains($argv," ") == 1) THEN
				renameSel(0,$argv);
			ELSE
				privMsg($oss_errorMsg_color."This command takes 2 parameters");
			ENDIF
		BREAK;
		
		CASE "!delsel":		# delete selection from database
			IF($argv != "") THEN
				deleteSel(0,$argv);
			ELSE
				privMsg($oss_errorMsg_color."You need to specify the name");
			ENDIF
		BREAK;
		
	ENDSWITCH
EndCatchEvent

# Enable $DisplayObjectInfo in the main .lpr script!
CatchEvent OnObjectInfo($userName,$NumO,$Action,$ObjectsInfo) # Player event
	### request from the save-selection action (saveSel)
	IF( $Action == 5 & GetCurrentPlayerVar("selectionName") != "") THEN 
		IF($NumO != 0) THEN
			$selectionName = GetCurrentPlayerVar("selectionName");
			
			$ListOfObjects = SplitToArray($ObjectsInfo,"|");
			FOR( $i=0; $i < ToNum($NumO) ; $i=$i+1 )
				$ObjectInfoArray = SplitToArray($ListOfObjects[$i],":");
				
				$X = $ObjectInfoArray[0];
				$Y = $ObjectInfoArray[1];
				$Z = round($ObjectInfoArray[2] / 4,2); # convert for use with object functions (e.g. addobject)
				$Heading = round(($ObjectInfoArray[3] * 1.40625)-180,0); # convert for use with object functions (e.g. addobject)
				$Flag = $ObjectInfoArray[4];
				$Index = $ObjectInfoArray[5];
				
				# object function format -> "X:Y:Z:Flag:Index:Heading"
				IF( $i == 0) THEN
					$objects = $X . ":" . $Y . ":" . $Z . ":" . $Flag . ":" . $Index . ":" . $Heading	;
				ELSE
					$objects = $objects . "," . $X . ":" . $Y . ":" . $Z . ":" . $Flag . ":" . $Index . ":" . $Heading	;
				ENDIF		
			ENDFOR
			
			EditFile($oss_dbsFileName,$oss_dbsPath,$selectionName."|".GetLapperVar("ShortDate")." ".GetLapperVar("LongTime")."|".$userName."|".$objects,-1,".ossdb");
			privMsg($selectionName . $oss_confirmMsg_color ." selection saved");
			
			# if this was call from GUI then set sorting to date_DESC, page to 1 and refresh page so new selection is first in list, but only if selMenu_CloseOnSave is false
			getUserSettings();
			IF(GetCurrentPlayerVar("isSepSaveButtCall") != 1 ) THEN
				IF(GetCurrentPlayerVar("isCmdCall") != 1 ) THEN
					IF(GetCurrentPlayerVar("selMenu_CloseOnSave") == 0) THEN
						SetCurrentPlayerVar("selMenu_SortBy", "date_DESC");
						SetCurrentPlayerVar("selMenu_CurrPage", 1);
						showSelMenuGUI(0,0);
					ELSE
						closeButtonRegex( $userName, "selMenu_" );
					ENDIF
				ELSE
					SetCurrentPlayerVar("isCmdCall", ""); # unset
				ENDIF
			ELSE # if this is call from separate Save button (without GUI)
				SetCurrentPlayerVar("isSepSaveButtCall", ""); # unset
			ENDIF
			SetCurrentPlayerVar("selectionName", ""); # unset
		ELSE
			privMsg($oss_errorMsg_color."No objects are selected");
		ENDIF
	ENDIF
	###

EndCatchEvent

CatchEvent OnInterfaceMode($userName,$Mode,$SubMode,$SelObject,$Time) # Player event
	SetCurrentPlayerVar("currInterfaceMode",$Mode);
EndCatchEvent

Sub showSelMenuGUI($ClickFlag,$buttID)
	$userName = GetCurrentPlayerVar("UserName");
	
	$sortByInfo = GetCurrentPlayerVar("selMenu_SortBy");
	$sortByInfoSplit = SplitToArray($sortByInfo,"_");
	$sortByItem = $sortByInfoSplit[0];
	$sortByType = $sortByInfoSplit[1];
	
	getUserSettings();
	$oss_itemsPerPage = GetCurrentPlayerVar("selMenu_ItemsPerPage");
	
	$LinesofFile = ReadFile($oss_dbsFileName,$oss_dbsPath,".ossdb");
	$NrOfLines = $LinesofFile["NumberOfLines"];
	$numOfPages = round((($NrOfLines-1) / $oss_itemsPerPage) + 0.5,0); # +0.5 to round up
	
### check if PageNum, prev, next, date or name button was pressed
	IF(Contains($buttID, "selMenu_PageNumButt_|")) THEN
		$buttIDInfo = SplitToArray($buttID,"|");
		$pageButtNum = $buttIDInfo[1];
		
		SetCurrentPlayerVar("selMenu_CurrPage",$pageButtNum);
	ELSE
		IF($buttID == "selMenu_NextButt") THEN
			IF($ClickFlag == 1) THEN
				SetCurrentPlayerVar("selMenu_CurrPage",GetCurrentPlayerVar("selMenu_CurrPage")+1);
			ELSE
				SetCurrentPlayerVar("selMenu_CurrPage",$numOfPages); # if this is right click then to the last page
			ENDIF
		ELSE
			IF($buttID == "selMenu_PrevButt") THEN
				IF($ClickFlag == 1) THEN
					SetCurrentPlayerVar("selMenu_CurrPage",GetCurrentPlayerVar("selMenu_CurrPage")-1);
				ELSE
					SetCurrentPlayerVar("selMenu_CurrPage",1); # if this is right click then to the first page
				ENDIF
				
			ELSE
				IF($buttID == "selMenu_Header_Date") THEN
					SetCurrentPlayerVar("selMenu_CurrPage",1);
					IF($sortByItem != "date") THEN	# if date wasn't selected already then set default sort type for it
						updateUserSort("date_DESC");
					ELSE							# else switch sort type
						IF($sortByType == "DESC") THEN
							updateUserSort("date_ASC");
						ELSE
							updateUserSort("date_DESC");
						ENDIF
					ENDIF
				ELSE
					IF($buttID == "selMenu_Header_Name") THEN
						SetCurrentPlayerVar("selMenu_CurrPage",1);
						IF($sortByItem != "name") THEN	# if name wasn't selected already then set default sort type for it
							updateUserSort("name_ASC");
						ELSE							# else switch sort type
							IF($sortByType == "ASC") THEN
								updateUserSort("name_DESC");
							ELSE
								updateUserSort("name_ASC");
							ENDIF
						ENDIF
					ELSE
						IF($buttID == "selMenu_Header_User") THEN
							SetCurrentPlayerVar("selMenu_CurrPage",1);
							IF($sortByItem != "user") THEN	# if user wasn't selected already then set default sort type for it
								updateUserSort("user_ASC");
							ELSE							# else switch sort type
								IF($sortByType == "ASC") THEN
									updateUserSort("user_DESC");
								ELSE
									updateUserSort("user_ASC");
								ENDIF
							ENDIF
							
						ELSE
							IF($buttID == "selMenu_Header_Count") THEN
								SetCurrentPlayerVar("selMenu_CurrPage",1);
								IF($sortByItem != "count") THEN	# if count wasn't selected already then set default sort type for it
									updateUserSort("count_DESC");
								ELSE							# else switch sort type
									IF($sortByType == "DESC") THEN
										updateUserSort("count_ASC");
									ELSE
										updateUserSort("count_DESC");
									ENDIF
								ENDIF
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ENDIF
		ENDIF
	ENDIF
	###
	
	getUserSettings();
	
	$plCurrPage = GetCurrentPlayerVar("selMenu_CurrPage");
	$numOfItemsOnLastPage = $NrOfLines-($oss_itemsPerPage * ($numOfPages-1));
	IF($plCurrPage != $numOfPages) THEN # if this is not last page
		$numOfItemsOnThisPage = $oss_itemsPerPage;
	ELSE
		$numOfItemsOnThisPage = $numOfItemsOnLastPage;
	ENDIF
	
	
	$oss_background_H = round($oss_boarderDOWN_H+$oss_boarderUP_H+($oss_itemsPerPage*$oss_header_items_H),0);
	$oss_header_items_Y = $oss_guiPos_Y+$oss_boarderUP_H-$oss_header_nduc_H;
	
	# colors
	$bkgrColor_light = ISB_LIGHT;
	$bkgrColor_dark = ISB_DARK;
	$textColor_white = "^7";
	$textColor_black = "^0";
	$textColor_noColor = "^8";
	
	$oss_background_color = $bkgrColor_light;
	$oss_titleText_color = $textColor_black;
	$oss_SaveSelBkgr_color = $bkgrColor_dark;
	$oss_PlusMinusBkgr_color = $bkgrColor_dark;
	$oss_ItemsPerPageBkgr_color = $bkgrColor_light;
	$oss_columnTitleUnselected_color = $textColor_black;
	$oss_columnTitleSelected_color = $textColor_white;
	$oss_columnTitleBkgr = $bkgrColor_light;
	$oss_ItemText_color = $textColor_white;
	$oss_ItemBkgr_color = $bkgrColor_dark;
	$oss_NextPrev_color = $bkgrColor_dark;
	$oss_NextPrevText_color = $textColor_white;
	$oss_CloseBkgr_color = $bkgrColor_light;
	
	### show header items
	getUserSettings();
	$columnTitleText_Name = "%nl%".$oss_columnTitleUnselected_color."name";
	$columnTitleText_Count = "%nl%".$oss_columnTitleUnselected_color."objects"; 
	$columnTitleText_Date = "%nl%".$oss_columnTitleUnselected_color."date"; 
	$columnTitleText_User = "%nl%".$oss_columnTitleUnselected_color."user"; 
	
	IF(GetCurrentPlayerVar("selMenu_SortBy") == "date_DESC") THEN
		$columnTitleText_Date = $oss_columnTitleSelected_color."▽%nl%".$oss_columnTitleSelected_color."date"; 
	ELSE
		IF(GetCurrentPlayerVar("selMenu_SortBy") == "name_ASC") THEN
			$columnTitleText_Name = $oss_columnTitleSelected_color."△%nl%".$oss_columnTitleSelected_color."name";
		ELSE
			IF(GetCurrentPlayerVar("selMenu_SortBy") == "user_ASC") THEN
				$columnTitleText_User = $oss_columnTitleSelected_color."△%nl%".$oss_columnTitleSelected_color."user";
			ELSE
				IF(GetCurrentPlayerVar("selMenu_SortBy") == "count_DESC") THEN
					$columnTitleText_Count = $oss_columnTitleSelected_color."▽%nl%".$oss_columnTitleSelected_color."objects";
				ELSE
					IF(GetCurrentPlayerVar("selMenu_SortBy") == "date_ASC") THEN
						$columnTitleText_Date = $oss_columnTitleSelected_color."△%nl%".$oss_columnTitleSelected_color."date"; 
					ELSE
						IF(GetCurrentPlayerVar("selMenu_SortBy") == "name_DESC") THEN
							$columnTitleText_Name = $oss_columnTitleSelected_color."▽%nl%".$oss_columnTitleSelected_color."name";
						ELSE
							IF(GetCurrentPlayerVar("selMenu_SortBy") == "user_DESC") THEN
								$columnTitleText_User = $oss_columnTitleSelected_color."▽%nl%".$oss_columnTitleSelected_color."user";
							ELSE
								IF(GetCurrentPlayerVar("selMenu_SortBy") == "count_ASC") THEN
									$columnTitleText_Count = $oss_columnTitleSelected_color."△%nl%".$oss_columnTitleSelected_color."objects";
								ENDIF
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ENDIF
		ENDIF
	ENDIF
	
	# show the menu
	openPrivButton( "selMenu_Background",
		$oss_background_X,
		$oss_background_Y,
		$oss_background_W,
		$oss_background_H,
		10,
		-1,
		$oss_background_color,
		"",
		"");
		
	openPrivButton( "selMenu_Header_Title",
		$oss_guiPos_X - 15,
		$oss_background_Y,
		30,
		10,
		10,
		-1,
		0,
		$oss_titleText_color."Load Selection",
		"");

	openPrivTextButton( "selMenu_Header_SaveSel",
		($oss_guiPos_X-($oss_header_items_W / 2)) + (($oss_header_name_W/2)-5),
		$oss_background_Y+3,
		10,
		4,
		3,
		4+$oss_SaveSelBkgr_color,
		"name the selection",
		"save%nl%current%nl%selection%nl% ▼",
		$oss_maxNameLenght,
		saveSel);
	
	openPrivButton( "selMenu_Header_ItemsPerPageText",
		$oss_guiPos_X - 7,
		$oss_background_Y+8,
		14,
		4,
		2,
		-1,
		7,
		"Items per page: ",
		"");	
	
		openPrivTextButton( "selMenu_Header_ItemsPerPageNum",
			$oss_guiPos_X - 2,
			$oss_background_Y+12,
			4,
			4,
			1,
			$oss_ItemsPerPageBkgr_color,
			"set number of items per page",
			"^7".$oss_itemsPerPage,
			2,
			updateUserItemsPerPageTB);
			
			IF($oss_itemsPerPage != $oss_minItemsPerPage) THEN
				openPrivButton( "selMenu_Header_ItemsPerPageMinus",
					$oss_guiPos_X-4,
					$oss_background_Y+12,
					2,
					4,
					2,
					-1,
					$oss_PlusMinusBkgr_color,
					"^7-",
					updateUserItemsPerPage);
			ELSE
				closePrivButton("selMenu_Header_ItemsPerPageMinus");
			ENDIF
			
			IF($oss_itemsPerPage != $oss_maxItemsPerPage) THEN
				openPrivButton( "selMenu_Header_ItemsPerPagePlus",
					$oss_guiPos_X+2,
					$oss_background_Y+12,
					2,
					4,
					2,
					-1,
					$oss_PlusMinusBkgr_color,
					"^7+",
					updateUserItemsPerPage);
			ELSE
				closePrivButton("selMenu_Header_ItemsPerPagePlus");
			ENDIF
	
	openPrivButton( "selMenu_Header_Name",
		$oss_guiPos_X-($oss_header_items_W / 2),
		$oss_header_items_Y-2,
		$oss_header_name_W,
		$oss_header_nduc_H,
		2,
		-1,
		$oss_columnTitleBkgr,
		$columnTitleText_Name,
		showSelMenuGUI);
		
	openPrivButton( "selMenu_Header_Count",
		$oss_guiPos_X-($oss_header_items_W / 2)+$oss_header_name_W,
		$oss_header_items_Y-2,
		$oss_header_count_W,
		$oss_header_nduc_H,
		2,
		-1,
		$oss_columnTitleBkgr,
		$columnTitleText_Count,
		showSelMenuGUI);
		
	openPrivButton( "selMenu_Header_Date",
		$oss_guiPos_X-($oss_header_items_W / 2)+$oss_header_name_W+$oss_header_count_W,
		$oss_header_items_Y-2,
		$oss_header_date_W,
		$oss_header_nduc_H,
		2,
		-1,
		$oss_columnTitleBkgr,
		$columnTitleText_Date,
		showSelMenuGUI);
		
	openPrivButton( "selMenu_Header_User",
		$oss_guiPos_X-($oss_header_items_W / 2)+$oss_header_name_W+$oss_header_count_W+$oss_header_date_W,
		$oss_header_items_Y-2,
		$oss_header_user_W,
		$oss_header_nduc_H,
		2,
		-1,
		$oss_columnTitleBkgr,
		$columnTitleText_User,
		showSelMenuGUI);
		
	openPrivButton( "selMenu_Header_DelBlank",
		$oss_guiPos_X-($oss_header_items_W / 2)+$oss_header_name_W+$oss_header_count_W+$oss_header_date_W+$oss_header_user_W,
		$oss_header_items_Y-2,
		$oss_header_del_W,
		$oss_header_nduc_H,
		2,
		-1,
		$oss_columnTitleBkgr,
		"%nl%",
		"");
		
	openPrivButton( "selMenu_Header_Close",
		$oss_background_X+$oss_background_W-9,
		$oss_background_Y-4,
		12,
		15,
		15,
		-1,
		5,
		"×",
		"");
		
		openPrivButton( "selMenu_Header_CloseBkgr",
			$oss_background_X+$oss_background_W-6,
			$oss_background_Y,
			6,
			8,
			15,
			-1,
			$oss_CloseBkgr_color,
			"",
			closeSelMenu);
			
	showLoadCloseButt();
	showSaveCloseButt();
	###

	
	
	
	# 	hide previous page items
	closeButtonRegex( $userName, "selMenu_ItemText_" );
	
	### sort items before showing
	
	getUserSettings();
	$new_sortByInfo = GetCurrentPlayerVar("selMenu_SortBy");
	$new_sortByInfoSplit = SplitToArray($new_sortByInfo,"_");
	$new_sortByItem = $new_sortByInfoSplit[0];
	$new_sortByType = $new_sortByInfoSplit[1];
	
	IF($new_sortByItem == "date") THEN		# sorting by date
		FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
			$line = ToString($LinesofFile[$i,"Line"]);
			
			## convert DMY HMS to YMD HMS
			$lineSelInfo = SplitToArray($line,"|");
			$lineSelDateTime = $lineSelInfo[1];
			$lineSelDateTime_split = SplitToArray($lineSelDateTime," ");
			$lineSel_date = $lineSelDateTime_split[0];
			
			$lineSel_date_split = SplitToArray($lineSel_date,"/");
			
			$lineSel_day = $lineSel_date_split[0];
			$lineSel_month = $lineSel_date_split[1];
			$lineSel_year = $lineSel_date_split[2];
			##
			
			$lineSelDateTimeNName = $lineSel_year . "/" . $lineSel_month . "/" . $lineSel_day . " " . $lineSelDateTime_split[1] . "|" . $lineSelInfo[0]; # datetime in YMD HMS + selName	
			$lineSelDateTimesNNames[$i] = ToString($lineSelDateTimeNName); # strip color so it doesn't sort with color tags
		ENDFOR
		$sortedSelItemsNNames = Sort($lineSelDateTimesNNames,$new_sortByType); # sort	
	ELSE
		IF($new_sortByItem == "name") THEN		# sorting by name_ASC
			
			FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
				$line = ToString($LinesofFile[$i,"Line"]);
				
				$splitCharID = indexOf( $line, "|");
				$lineSelName = remove($line,$splitCharID);
				
				$lineSelNames[$i] = StripLFSColor($lineSelName) . "|" . $lineSelName; # strip color for sorting, but also keep the nonstripped name
			ENDFOR
			$sortedSelItemsNNames = Sort($lineSelNames,$new_sortByType); # sort
		ELSE
			IF($new_sortByItem == "user") THEN		# sorting by user_ASC
				FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
					$line = ToString($LinesofFile[$i,"Line"]);
					
					$lineSelInfo = SplitToArray($line,"|");
					
					$lineSelUserNName = $lineSelInfo[2] . "|" . $lineSelInfo[0]; # user + selName	
					$lineSelUsersNNames[$i] = ToString($lineSelUserNName); 
				ENDFOR
				$sortedSelItemsNNames = Sort($lineSelUsersNNames,$new_sortByType); # sort		
			ELSE
				IF($new_sortByItem == "count") THEN		# sorting by count_DESC
					FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
						$line = ToString($LinesofFile[$i,"Line"]);
						
						$lineSelInfo = SplitToArray($line,"|");
						
						$lineSelObjInfo = $lineSelInfo[3];
						$lineSelObjInfoArray = SplitToArray($lineSelObjInfo,",");
						
						# convert X to 0X for sorting
						IF(arrayCount($lineSelObjInfoArray) < 10) THEN
							$lineSelCount = "0" . arrayCount($lineSelObjInfoArray);
						ELSE
							$lineSelCount = arrayCount($lineSelObjInfoArray);
						ENDIF
						
						$lineSelCountNName = $lineSelCount . "|" . $lineSelInfo[0]; # obj. count + selName	
						$lineSelCountsNNames[$i] = ToString($lineSelCountNName); 
					ENDFOR
					$sortedSelItemsNNames = Sort($lineSelCountsNNames,$new_sortByType); # sort
				ENDIF
			ENDIF
		ENDIF
	ENDIF
	
	# build sorted $LinesofFile array
	FOR ( $j = 0; $j <= $NrOfLines-1 ; $j = $j + 1)
		$line = ToString($LinesofFile[$j,"Line"]);
		
		IF($line != "") THEN
			$splitCharID = indexOf( $line, "|");
			$lineSelName = remove($line,$splitCharID);
		ENDIF
		
		$sortedSelItemsNNamesCount = arrayCount($sortedSelItemsNNames);
		
		FOR ( $k = 0; $k <= $sortedSelItemsNNamesCount ; $k = $k + 1)
			$sortedSelDateTimesNNames_split = SplitToArray($sortedSelItemsNNames[$k],"|");
			
			$sortedSelName = ToString($sortedSelDateTimesNNames_split[1]);
			
			IF($lineSelName == $sortedSelName) THEN
				$sortedLinesOfFile[$k] = ToString($line);
			ENDIF
		ENDFOR
	ENDFOR	
	###
	
	### show
	FOR ( $i = ($oss_itemsPerPage * $plCurrPage) - $oss_itemsPerPage; $i <= ($oss_itemsPerPage*$plCurrPage) - 1 ; $i = $i + 1)
		$line = ToString($sortedLinesOfFile[$i]);
		
		$item_Y = $oss_header_items_Y+$oss_header_nduc_H+($oss_items_offset*($i-(($oss_itemsPerPage * $plCurrPage) - $oss_itemsPerPage)));
		
		IF($line != "") THEN
			$lineSelInfo = SplitToArray($line,"|");
			
			$lineSelName = $lineSelInfo[0];
			$lineSelDateTime = $lineSelInfo[1];
			$lineSelUser = $lineSelInfo[2];
			$lineSelObjInfo = $lineSelInfo[3];
			$lineSelObjInfoArray = SplitToArray($lineSelObjInfo,",");
			$lineSelCount = arrayCount($lineSelObjInfoArray);
			
			openPrivButton( "selMenu_ItemText_Name_|".$lineSelName,
				$oss_guiPos_X-($oss_header_items_W / 2),
				$item_Y,
				$oss_header_name_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				$oss_ItemText_color.$lineSelName,
				loadSel);
					
			openPrivButton( "selMenu_ItemText_Count_|".$lineSelName,
				$oss_guiPos_X-($oss_header_items_W / 2)+$oss_header_name_W,
				$item_Y,
				$oss_header_count_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				$oss_ItemText_color.$lineSelCount,
				loadSel);
				
			openPrivButton( "selMenu_ItemText_Date_|".$lineSelName,
				($oss_guiPos_X-($oss_header_items_W / 2))+$oss_header_count_W+$oss_header_name_W,
				$item_Y,
				$oss_header_date_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				$oss_ItemText_color.$lineSelDateTime,
				loadSel);
				
			openPrivButton( "selMenu_ItemText_User_|".$lineSelName,
				($oss_guiPos_X-($oss_header_items_W / 2))+$oss_header_count_W+$oss_header_name_W+$oss_header_date_W,
				$item_Y,
				$oss_header_user_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				$oss_ItemText_color.$lineSelUser,
				loadSel);
			
			# open rename and delete buttons if current user is the selection creator or is Lapper superuser
			UserGroupFromFile( "superusers", "./superusers.txt" );
			IF($userName == $lineSelUser || UserInGroup( "superusers",$userName)) THEN
				openPrivTextButton( "selMenu_ItemText_Rename_|".$lineSelName,
					$oss_guiPos_X-($oss_header_items_W / 2)+$oss_header_name_W-$oss_header_ren_W,
					$item_Y,
					$oss_header_ren_W,
					round(($oss_header_items_H/2)+0.5,0),
					1,
					4+ISB_DARK,
					"rename the selection",
					"rename",
					$oss_maxNameLenght,
					renameSel);
					
				openPrivTextButton( "selMenu_ItemText_Delete_|".$lineSelName,
					($oss_guiPos_X-($oss_header_items_W / 2))+$oss_header_count_W+$oss_header_name_W+$oss_header_date_W+$oss_header_user_W,
					$item_Y,
					$oss_header_del_W,
					$oss_header_items_H,
					1,
					5+$oss_ItemBkgr_color,
					"^3Delete '^8" . $lineSelName . "^3'? Type 'y' to confirm..",
					"DEL",
					1,
					deleteSel);
			ELSE # else show blank DEL button	
				openPrivButton( "selMenu_ItemText_Delete_BLANK_|".$lineSelName,
					($oss_guiPos_X-($oss_header_items_W / 2))+$oss_header_count_W+$oss_header_name_W+$oss_header_date_W+$oss_header_user_W,
					$item_Y,
					$oss_header_del_W,
					$oss_header_items_H,
					0,
					-1,
					5+ISB_DARK,
					"-",
					"");
			ENDIF
		ELSE	# show blank buttons on last page
			openPrivButton( "selMenu_ItemText_Name_|".$i,
				$oss_guiPos_X-($oss_header_items_W / 2),
				$item_Y,
				$oss_header_name_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				"",
				"");
					
			openPrivButton( "selMenu_ItemText_Count_|".$i,
				$oss_guiPos_X-($oss_header_items_W / 2)+$oss_header_name_W,
				$item_Y,
				$oss_header_count_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				"",
				"");
				
			openPrivButton( "selMenu_ItemText_Date_|".$i,
				($oss_guiPos_X-($oss_header_items_W / 2))+$oss_header_count_W+$oss_header_name_W,
				$item_Y,
				$oss_header_date_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				"",
				"");
				
			openPrivButton( "selMenu_ItemText_User_|".$i,
				($oss_guiPos_X-($oss_header_items_W / 2))+$oss_header_count_W+$oss_header_name_W+$oss_header_date_W,
				$item_Y,
				$oss_header_user_W,
				$oss_header_items_H,
				0,
				-1,
				$oss_ItemBkgr_color,
				"",
				"");
				
			openPrivButton( "selMenu_ItemText_Delete_BLANK_|".$i,
				($oss_guiPos_X-($oss_header_items_W / 2))+$oss_header_count_W+$oss_header_name_W+$oss_header_date_W+$oss_header_user_W,
				$item_Y,
				$oss_header_del_W,
				$oss_header_items_H,
				0,
				-1,
				5+ISB_DARK,
				"",
				"");
		ENDIF
	ENDFOR
	###
	
	### show/hide paging buttons
	$pageNum_W = 2;
	$pagePrevNext_W = 3;
	$pageNumButtons_H = 3;
	$pageNumButtons_W = $numOfPages*$pageNum_W;
	$pageNumButtons_X = $oss_guiPos_X - ($pageNumButtons_W / 2);
	$pageNumButtons_Y = $oss_guiPos_Y + $oss_background_H - ($pageNumButtons_H + 2);
	$prev_X = $pageNumButtons_X - ($prev_W + $pagePrevNext_W);
	$next_X = $pageNumButtons_X + $pageNumButtons_W;

	# prevButt
	IF($plCurrPage != 1) THEN # if this is not first page
		openPrivButton( "selMenu_PrevButt",
			$prev_X,
			$pageNumButtons_Y,
			$pagePrevNext_W,
			$pageNumButtons_H,
			10,
			-1,
			$oss_NextPrev_color,
			$oss_NextPrevText_color . "<",
			showSelMenuGUI);
	ELSE
		closePrivButton("selMenu_PrevButt");
	ENDIF
	
	# pageNum buttons
	closeButtonRegex( $userName, "selMenu_PageNumButt_" );
	IF(ToNum($numOfPages) != 1 && ToNum($numOfPages) != 0) THEN	# no need to show page number number of pages is 1 or 0 (no records)
		FOR( $i=0; $i < ToNum($numOfPages); $i=$i+1 )
			IF($i+1 == $plCurrPage) THEN
				$pageNum_color = "^7";
			ELSE
				$pageNum_color = "^0";
			ENDIF
			openPrivButton( "selMenu_PageNumButt_|".$i+1,
				$pageNumButtons_X + ($i*$pageNum_W),
				$pageNumButtons_Y,
				$pageNum_W,
				$pageNumButtons_H,
				10,
				-1,
				ISB_LIGHT,
				$pageNum_color . $i+1,
				showSelMenuGUI);
		ENDFOR
	ENDIF
	
	# nextButt
	IF($plCurrPage != $numOfPages && ToNum($numOfPages) != 0) THEN	# do not show if this is last page or if there are no records
		openPrivButton( "selMenu_NextButt",
			$next_X,
			$pageNumButtons_Y,
			$pagePrevNext_W,
			$pageNumButtons_H,
			10,
			-1,
			ISB_C1+$oss_NextPrev_color,
			$oss_NextPrevText_color . ">",
			showSelMenuGUI);
	ELSE
		closePrivButton("selMenu_NextButt");
	ENDIF
	###
EndSub

Sub loadSel($ClickFlag,$argv)
# $argv is button ID if clickFlag is 1 or 2

	$userName = GetCurrentPlayerVar("UserName");
	IF(UserIsServerAdmin($userName) == 1) THEN 
		IF($ClickFlag != 2) THEN
			IF(GetCurrentPlayerVar("currInterfaceMode") == 6) THEN # if in Shift+U mode / SetLytSelection works in all SubModes so no check for that is needed
				IF($ClickFlag != 0) THEN # if this is not !loadsel command request
					$splitCharID = indexOf( $argv, "|");
					$selName = subStr($argv, $splitCharID+1, strLen($argv));
				ELSE
					$selName = $argv;
				ENDIF
				
				IF($selName != "") THEN
					
					$LinesofFile = ReadFile($oss_dbsFileName,$oss_dbsPath,".ossdb");
					$NrOfLines = $LinesofFile["NumberOfLines"];
					FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
						$linenr = $LinesofFile[$i,"LineNumber"];
						$line = $LinesofFile[$i,"Line"];
						
						$lineSelInfo = SplitToArray($line,"|");
						$lineSelName = $lineSelInfo[0];
						
						IF($lineSelName == $selName) THEN
							$objects = $lineSelInfo[3];
							BREAK; # we've found the selection -> break out from the FOR loop
						ENDIF
					ENDFOR
					
					IF($objects != "") THEN # continue if selection was found
						SetLytSelection(0,$objects);	# all set, we can set the selection to clipboard
						getUserSettings();
						IF(GetCurrentPlayerVar("selMenu_CloseOnLoad") == 1) THEN
							closeButtonRegex( $userName, "selMenu_" );
						ENDIF
						privMsg($oss_confirmMsg_color"selection copied to clipboard");
					ELSE
						privMsg($oss_errorMsg_color."Nothing found");
					ENDIF
				ELSE
					privMsg($oss_errorMsg_color."You need to specify the name");
				ENDIF
			ELSE
				privMsg($oss_errorMsg_color."Only for Shift+U mode");
			ENDIF
		ELSE	# copy name to chat on rightclick
			$splitCharID = indexOf( $argv, "|");
			$selName = subStr($argv, $splitCharID+1, strLen($argv));
			privMsg($selName);
		ENDIF
	ELSE
		privMsg($oss_errorMsg_color."Only for server admins");
	ENDIF
EndSub

Sub saveSel($buttID,$argv)
	$userName = GetCurrentPlayerVar("UserName");
	
	IF(UserIsServerAdmin($userName) == 1) THEN
		IF (Contains($argv,"|") != 1) THEN
			IF(GetCurrentPlayerVar("currInterfaceMode") == 6) THEN # check if in Shift+U mode
				IF($argv != "") THEN
					# check if selection with such name already exists
					$LinesofFile = ReadFile($oss_dbsFileName,$oss_dbsPath,".ossdb");
					$NrOfLines = $LinesofFile["NumberOfLines"];
					FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
						$linenr = $LinesofFile[$i,"LineNumber"];
						$line = $LinesofFile[$i,"Line"];
						
						$splitCharID = indexOf( $line, "|");
						$lineSelName = remove($line,$splitCharID);
						IF($lineSelName == $argv) THEN
							$nameFound = 1;
							BREAK; # break out from the FOR loop
						ENDIF
					ENDFOR
					
					# if not then save the selection
					IF($nameFound != 1) THEN
						SetCurrentPlayerVar("selectionName", $argv);
						
						# check if this is call from separate Save button
						IF($buttID == "selMenu_Header_SaveSelSep") THEN
							SetCurrentPlayerVar("isSepSaveButtCall",1);
						ELSE
							# check if this is call from !savesel command
							IF($buttID == 0) THEN
								SetCurrentPlayerVar("isCmdCall",1);
							ENDIF
						ENDIF
						
						GetLytSelection(); # request OnObjectInfo to get current selection
					ELSE
						privMsg($oss_errorMsg_color."Selection with such name already exists");
					ENDIF
				ELSE
					privMsg($oss_errorMsg_color."You need to specify the name");
				ENDIF
			ELSE
				privMsg($oss_errorMsg_color."Only for Shift+U mode");
			ENDIF
		ELSE
			privMsg($oss_errorMsg_color."Sorry, the name cannot contain '|' char");
		ENDIF
	ELSE
		privMsg($oss_errorMsg_color."only for server admins");
	ENDIF
EndSub

Sub renameSel($buttID,$argv)
IF($buttID == 0) THEN
	$spaceIndex = indexof( $argv, " " );
	$oldSelName = subStr($argv, 0, $spaceIndex);
	$newSelName = trim(subStr($argv, $spaceIndex, strLen($argv)));
ELSE
	$spaceIndex = indexof( $buttID, "|" );
	$oldSelName = subStr($buttID, $spaceIndex+1, strLen($buttID));
	$newSelName = $argv;
ENDIF

	IF($argv != "") THEN
		IF (Contains($newSelName,"|") != 1) THEN
			$LinesofFile = ReadFile($oss_dbsFileName,$oss_dbsPath,".ossdb");
			$NrOfLines = $LinesofFile["NumberOfLines"];
			# first check if new name is not already taken
			FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
				$linenr = $LinesofFile[$i,"LineNumber"]+1;
				$line = $LinesofFile[$i,"Line"];
				
				$splitCharID = indexOf( $line, "|");
				$lineSelName = remove($line,$splitCharID);
				
				IF($lineSelName == $newSelName) THEN
					$nameExists = 1;
					BREAK; # break out from the FOR loop
				ENDIF
			ENDFOR
			
			IF($nameExists != 1) THEN
				# find the selection
				FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
					$linenr = $LinesofFile[$i,"LineNumber"]+1;
					$line = $LinesofFile[$i,"Line"];
					
					$lineSelInfo = SplitToArray($line,"|");
					
					$lineSelName = $lineSelInfo[0];
					$lineSelDateTime = $lineSelInfo[1];
					$lineSelUser = $lineSelInfo[2];
					$lineSelObjInfo = $lineSelInfo[3];
					
					IF($lineSelName == $oldSelName) THEN
						$nameFound = 1;
						BREAK; # break out from the FOR loop
					ENDIF
				ENDFOR
				
				# if found then update the selection info
				IF($nameFound == 1) THEN
					$updatedLine = $newSelName."|".$lineSelDateTime."|".$lineSelUser."|".$lineSelObjInfo;
					EditFile($oss_dbsFileName,$oss_dbsPath,$updatedLine,ToNum($linenr),".ossdb");
					privMsg($oss_confirmMsg_color."Selection '^8" . $oldSelName . $oss_confirmMsg_color . "' renamed to '^8" . $newSelName . $oss_confirmMsg_color . "'");
					IF($buttID != 0) THEN # if this is call from the GUI
						showSelMenuGUI(0,0); # refresh the page
					ENDIF
				ELSE
					privMsg($oss_errorMsg_color."Selection with such name doesn't exist");
				ENDIF
			ELSE
				privMsg($oss_errorMsg_color."Selection with such name already exists");
			ENDIF
		ELSE
			privMsg($oss_errorMsg_color."Sorry, the name cannot contain '|' char");
		ENDIF
	ENDIF
EndSub

Sub deleteSel($buttID,$argv)
	IF($buttID != 0) THEN
		IF(ToLower($argv) == "y") THEN
			$splitCharID = indexOf( $buttID, "|");
			$selNameToDelete = subStr($buttID, $splitCharID+1, strLen($buttID));
		ENDIF
	ELSE
		$selNameToDelete = $argv;
	ENDIF
	
	IF(UserIsServerAdmin($userName) == 1) THEN 
		IF($selNameToDelete != "") THEN
			$LinesofFile = ReadFile($oss_dbsFileName,$oss_dbsPath,".ossdb");
			$NrOfLines = $LinesofFile["NumberOfLines"];
			FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
				$linenr = $LinesofFile[$i,"LineNumber"]+1;
				$line = $LinesofFile[$i,"Line"];
				
				$splitCharID = indexOf( $line, "|");
				$lineSelName = remove($line,$splitCharID);
				IF($lineSelName == $selNameToDelete) THEN
					EditFile($oss_dbsFileName,$oss_dbsPath,-1,ToNum($linenr),".ossdb"); # delete line
					IF($buttID != 0) THEN # if this is call from the GUI
						showSelMenuGUI(0,0); # refresh the page
					ENDIF
					$nameFound = 1;
					BREAK; # we've found the selection -> break out from the FOR loop
				ENDIF
			ENDFOR
			
			IF($nameFound == 1) THEN
				privMsg($oss_confirmMsg2_color."Selection '^8" . $selNameToDelete . $oss_confirmMsg2_color ."' deleted from database");
			ELSE
				privMsg($oss_errorMsg_color."Selection with such name doesn't exist.");
			ENDIF
		ELSE
			privMsg($oss_errorMsg_color."You need to specify the name");
		ENDIF
	ELSE
		privMsg($oss_errorMsg_color."Only for server admins");
	ENDIF
EndSub

Sub closeSelMenu($ClickFlag,$buttID)
	$userName = GetCurrentPlayerVar("UserName");
	closeButtonRegex( $userName, "selMenu_" );
EndSub

Sub getUserSettings()
	$userName = GetCurrentPlayerVar("UserName");
				
	$LinesofFile = ReadFile($oss_cfgFileName,$oss_cfgPath,".osscf");
	$NrOfLines = $LinesofFile["NumberOfLines"];
	FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
		$linenr = $LinesofFile[$i,"LineNumber"]+1;
		$line = $LinesofFile[$i,"Line"];
		
		$cfgLineInfo = SplitToArray($line,"|");
		$cfgLineUserName = $cfgLineInfo[0];
		$cfgLineSortInfo = $cfgLineInfo[1];
		$cfgLineItemsPerPage = $cfgLineInfo[2];
		$cfgLineCloseOnLoad = $cfgLineInfo[3];
		$cfgLineCloseOnSave = $cfgLineInfo[4];
		IF($cfgLineUserName == $userName) THEN
			SetCurrentPlayerVar("selMenu_SortBy",$cfgLineSortInfo);
			SetCurrentPlayerVar("selMenu_ItemsPerPage",$cfgLineItemsPerPage);
			SetCurrentPlayerVar("selMenu_CloseOnLoad",$cfgLineCloseOnLoad);
			SetCurrentPlayerVar("selMenu_CloseOnSave",$cfgLineCloseOnSave);
			BREAK;
		ENDIF
	ENDFOR
EndSub

Sub updateUserSort($newSortInfo)
	$userName = GetCurrentPlayerVar("UserName");

	$LinesofFile = ReadFile($oss_cfgFileName,$oss_cfgPath,".osscf");
	$NrOfLines = $LinesofFile["NumberOfLines"];
	FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
		$linenr = $LinesofFile[$i,"LineNumber"]+1;
		$line = $LinesofFile[$i,"Line"];
		
		$cfgLineInfo = SplitToArray($line,"|");
		$cfgLineUserName = $cfgLineInfo[0];
		$cfgLineSortInfo = $cfgLineInfo[1];
		$cfgLineItemsPerPage = $cfgLineInfo[2];
		$cfgLineCloseOnLoad = $cfgLineInfo[3];
		$cfgLineCloseOnSave = $cfgLineInfo[4];
		IF($cfgLineUserName == $userName) THEN
			$userFound = 1;
			BREAK;
		ENDIF
	ENDFOR
	
	IF($userFound == 1) THEN
		$newLine = $userName."|".$newSortInfo."|".$cfgLineItemsPerPage."|".$cfgLineCloseOnLoad."|".$cfgLineCloseOnSave;
		EditFile($oss_cfgFileName,$oss_cfgPath,$newLine,ToString($linenr),".osscf");
	ENDIF
EndSub

Sub updateUserItemsPerPage($ClickFlag,$buttID)
	$userName = GetCurrentPlayerVar("UserName");

	$LinesofFile = ReadFile($oss_cfgFileName,$oss_cfgPath,".osscf");
	$NrOfLines = $LinesofFile["NumberOfLines"];
	FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
		$linenr = $LinesofFile[$i,"LineNumber"]+1;
		$line = $LinesofFile[$i,"Line"];
		
		$cfgLineInfo = SplitToArray($line,"|");
		$cfgLineUserName = $cfgLineInfo[0];
		$cfgLineSortInfo = $cfgLineInfo[1];
		$cfgLineItemsPerPage = $cfgLineInfo[2];
		$cfgLineCloseOnLoad = $cfgLineInfo[3];
		$cfgLineCloseOnSave = $cfgLineInfo[4];
		IF($cfgLineUserName == $userName) THEN
			$userFound = 1;
			BREAK;
		ENDIF
	ENDFOR
	
	IF($userFound == 1) THEN
		IF($buttID == "selMenu_Header_ItemsPerPagePlus") THEN
			IF($ClickFlag == 1) THEN
				$cfgLineItemsPerPage = $cfgLineItemsPerPage + 1;
			ELSE
				$cfgLineItemsPerPage = $cfgLineItemsPerPage + 5;
			ENDIF
		ELSE # else this is minus button
			IF($ClickFlag == 1) THEN
				$cfgLineItemsPerPage = $cfgLineItemsPerPage - 1;
			ELSE
				$cfgLineItemsPerPage = $cfgLineItemsPerPage - 5;
			ENDIF
		ENDIF
		IF($cfgLineItemsPerPage < $oss_minItemsPerPage) THEN
			$cfgLineItemsPerPage = $oss_minItemsPerPage;
		ELSE
			IF($cfgLineItemsPerPage > $oss_maxItemsPerPage) THEN
				$cfgLineItemsPerPage = $oss_maxItemsPerPage;
			ENDIF
		ENDIF
		$updatedLine = $userName."|".$cfgLineSortInfo."|".$cfgLineItemsPerPage."|".$cfgLineCloseOnLoad."|".$cfgLineCloseOnSave;
		EditFile($oss_cfgFileName,$oss_cfgPath,$updatedLine,ToString($linenr),".osscf");
		
		SetCurrentPlayerVar("selMenu_CurrPage",1);
		showSelMenuGUI(0,0); # refresh the page
	ENDIF
EndSub

Sub updateUserItemsPerPageTB($buttID,$argv)
	$userName = GetCurrentPlayerVar("UserName");

	$LinesofFile = ReadFile($oss_cfgFileName,$oss_cfgPath,".osscf");
	$NrOfLines = $LinesofFile["NumberOfLines"];
	FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
		$linenr = $LinesofFile[$i,"LineNumber"]+1;
		$line = $LinesofFile[$i,"Line"];
		
		$cfgLineInfo = SplitToArray($line,"|");
		$cfgLineUserName = $cfgLineInfo[0];
		$cfgLineSortInfo = $cfgLineInfo[1];
		$cfgLineItemsPerPage = $cfgLineInfo[2];
		$cfgLineCloseOnLoad = $cfgLineInfo[3];
		$cfgLineCloseOnSave = $cfgLineInfo[4];
		IF($cfgLineUserName == $userName) THEN
			$userFound = 1;
			BREAK;
		ENDIF
	ENDFOR
	
	IF($userFound == 1) THEN
		IF($argv != "") THEN
		
			IF($argv^1 <= $oss_maxItemsPerPage && $argv^1 >= $oss_minItemsPerPage) THEN # pow the string to make sure its a numeric value (<text>^1=1 so text will not go through if $min>1)
				$cfgLineItemsPerPage = $argv;
				
				$updatedLine = $userName."|".$cfgLineSortInfo."|".$cfgLineItemsPerPage."|".$cfgLineCloseOnLoad."|".$cfgLineCloseOnSave;
				EditFile($oss_cfgFileName,$oss_cfgPath,$updatedLine,ToString($linenr),".osscf");
				
				SetCurrentPlayerVar("selMenu_CurrPage",1);
				showSelMenuGUI(0,0); # refresh the page
			ELSE
				privMsg($oss_errorMsg_color."must be number between " . $oss_minItemsPerPage . " and ".$oss_maxItemsPerPage);
			ENDIF
		
		ENDIF
	ENDIF
EndSub

Sub showLoadCloseButt()
	$userName = GetCurrentPlayerVar("UserName");

	openPrivButton( "selMenu_Header_LoadClose",
		($oss_background_X+round(($oss_header_items_W/4)*3,0))-2,
		$oss_background_Y+5,
		17,
		4,
		15,
		-1,
		ISB_LIGHT,
		"^0Close after loading:",
		"");
		
		getUserSettings();
		IF(GetCurrentPlayerVar("selMenu_CloseOnLoad") == 1) THEN
			$loadCloseSwitchText = "yes";
			$loadCloseSwitchText_color = 5;
		ELSE
			$loadCloseSwitchText = "no";
			$loadCloseSwitchText_color = 4;
		ENDIF
		openPrivButton( "selMenu_Header_LoadCloseSwitch",
			($oss_background_X+round(($oss_header_items_W/4)*3,0)+17)-2,
			$oss_background_Y+5,
			4,
			4,
			15,
			-1,
			$loadCloseSwitchText_color+ISB_DARK,
			$loadCloseSwitchText,
			updateUserLoadClose);
EndSub

Sub updateUserLoadClose($ClickFlag,$buttID)
	$userName = GetCurrentPlayerVar("UserName");

	$LinesofFile = ReadFile($oss_cfgFileName,$oss_cfgPath,".osscf");
	$NrOfLines = $LinesofFile["NumberOfLines"];
	FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
		$linenr = $LinesofFile[$i,"LineNumber"]+1;
		$line = $LinesofFile[$i,"Line"];
		
		$cfgLineInfo = SplitToArray($line,"|");
		$cfgLineUserName = $cfgLineInfo[0];
		$cfgLineSortInfo = $cfgLineInfo[1];
		$cfgLineItemsPerPage = $cfgLineInfo[2];
		$cfgLineCloseOnLoad = $cfgLineInfo[3];
		$cfgLineCloseOnSave = $cfgLineInfo[4];
		IF($cfgLineUserName == $userName) THEN
			$userFound = 1;
			BREAK;
		ENDIF
	ENDFOR
	
	IF($userFound == 1) THEN
		IF($cfgLineCloseOnLoad == 1) THEN
			$closeOnLoad = 0;
		ELSE
			$closeOnLoad = 1;
		ENDIF
		$updatedLine = $userName."|".$cfgLineSortInfo."|".$cfgLineItemsPerPage."|".$closeOnLoad."|".$cfgLineCloseOnSave;
		EditFile($oss_cfgFileName,$oss_cfgPath,$updatedLine,ToString($linenr),".osscf");
		showLoadCloseButt();
	ENDIF
EndSub

Sub showSaveCloseButt()
	$userName = GetCurrentPlayerVar("UserName");

	openPrivButton( "selMenu_Header_SaveClose",
		($oss_background_X+round(($oss_header_items_W/4)*3,0))-2,
		$oss_background_Y+10,
		17,
		4,
		15,
		-1,
		ISB_LIGHT,
		"^0Close after saving:",
		"");
		
		getUserSettings();
		IF(GetCurrentPlayerVar("selMenu_CloseOnSave") == 1) THEN
			$saveCloseSwitchText = "yes";
			$saveCloseSwitchText_color = 5;
		ELSE
			$saveCloseSwitchText = "no";
			$saveCloseSwitchText_color = 4;
		ENDIF
		openPrivButton( "selMenu_Header_SaveCloseSwitch",
			($oss_background_X+round(($oss_header_items_W/4)*3,0)+17)-2,
			$oss_background_Y+10,
			4,
			4,
			15,
			-1,
			$saveCloseSwitchText_color+ISB_DARK,
			$saveCloseSwitchText,
			updateUserSaveClose);
EndSub

Sub updateUserSaveClose($ClickFlag,$buttID)
	$userName = GetCurrentPlayerVar("UserName");

	$LinesofFile = ReadFile($oss_cfgFileName,$oss_cfgPath,".osscf");
	$NrOfLines = $LinesofFile["NumberOfLines"];
	FOR ( $i = 0; $i <= $NrOfLines-1 ; $i = $i + 1)
		$linenr = $LinesofFile[$i,"LineNumber"]+1;
		$line = $LinesofFile[$i,"Line"];
		
		$cfgLineInfo = SplitToArray($line,"|");
		$cfgLineUserName = $cfgLineInfo[0];
		$cfgLineSortInfo = $cfgLineInfo[1];
		$cfgLineItemsPerPage = $cfgLineInfo[2];
		$cfgLineCloseOnLoad = $cfgLineInfo[3];
		$cfgLineCloseOnSave = $cfgLineInfo[4];
		IF($cfgLineUserName == $userName) THEN
			$userFound = 1;
			BREAK;
		ENDIF
	ENDFOR
	
	IF($userFound == 1) THEN
		IF($cfgLineCloseOnSave == 1) THEN
			$closeOnSave = 0;
		ELSE
			$closeOnSave = 1;
		ENDIF
		$updatedLine = $userName."|".$cfgLineSortInfo."|".$cfgLineItemsPerPage."|".$cfgLineCloseOnLoad."|".$closeOnSave;
		EditFile($oss_cfgFileName,$oss_cfgPath,$updatedLine,ToString($linenr),".osscf");
		showSaveCloseButt();
	ENDIF
EndSub
